#include <dos.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <iostream.h>
#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <stdlib.h>

#define TOOLBARSIZE 12

#define NORMAL 0
#define TOGGLE 1

#define TRUE 1
#define FALSE 0

#define ON 1
#define OFF 0


#define NONE -1
#define SELECT 0
#define RUBBER 1
#define FILL 2
#define SPRAY 3
#define PENCIL 4
#define BRUSH 5
#define LINE 6
#define CURVE 7
#define RECTANGLE 8
#define POLYGON 9
#define ELLIPSE 10
#define INSERTTEXT 11
#define ART 12
#define SPIRAL 13

#define SMALLCIRCLE 0
#define BIGCIRCLE 1
#define SMALLSQUARE 2
#define BIGSQUARE 3
class button;
class layout;
class pointQueue;
class pointQueueItem;

initmouse ();
void restrictmouseptr (int, int, int, int);
void hidemouseptr ();
void showmouseptr ();
void getmousepos (int *butt, int *x, int *y);
void defaultButtonAction (layout *layout1, int mouseButton, int row, int col);
void quit (layout *layout1, int mouseButton, int row, int col);
void drawShadowBox (int x1, int y1, int x2, int y2, int flag = 1);
void swap (int &a, int &b);
void swap (int &a, int &b)
{
	int temp = a;
	a = b;
	b = temp;
}

union REGS i, o;

int color[16] = { BLACK, WHITE, DARKGRAY, LIGHTGRAY, BLUE, LIGHTBLUE, CYAN, LIGHTCYAN, RED, LIGHTRED, MAGENTA, LIGHTMAGENTA, BROWN, YELLOW, GREEN, LIGHTGREEN};

class pointQueue {
	public:
		pointQueue ();
		~pointQueue ();
		void add (int x, int y);
		void remove (int &x, int &y);
		int empty () { return (_first == NULL);}
	private :
		pointQueueItem *_first, *_last;
};

class pointQueueItem {
	public :
		pointQueueItem (int x, int y, pointQueueItem *next);
		~pointQueueItem () {}
		int x () { return _x;}
		int y () { return _y;}
		pointQueueItem* & next () { return _next;}
	private :
		int _x;
		int _y;
		pointQueueItem *_next;
};

pointQueueItem :: pointQueueItem (int x, int y, pointQueueItem *next)
{
	_x = x;
	_y = y;
	_next = next;
}

pointQueue :: pointQueue ()
{
	_first = NULL;
	_last = NULL;
}

pointQueue :: ~pointQueue ()
{
	pointQueueItem *temp = _first, *temp2;
	while (temp != NULL) {
		temp2 = temp;
		temp = temp->next();
		delete (temp2);
	}
}

void pointQueue :: add (int x, int y)
{
	pointQueueItem *temp = new pointQueueItem (x, y, NULL);
	if (_last != NULL)
		_last->next () = temp;
	else
		_first = temp;
	_last = temp;
}

void pointQueue :: remove (int &xval, int &yval)
{
	pointQueueItem *temp = _first;
	xval = temp->x();
	yval = temp->y();
	_first = temp->next();
	delete (temp);
	if (_first == NULL)
		_last = NULL;

}

class button {
	public :
		button () {}
		~button () {}
		void setProperties (int xl, int yt, int xr, int yb, int type = NORMAL, int stat = OFF, void (*act) (layout *, int, int, int) = 0);
		int & xLeft () {return _xLeft;}
		int & xRight () {return _xRight;}
		int & yTop () {return _yTop; }
		int & yBot () {return _yBot; }
		int checkRegion (int x, int y);
		int state ();
		int type ();
		void checkAndAct (layout *layout1, int x, int y, int mouseButton, int row, int col);
		void turnOn();
		void turnOff();
		void action (layout *layout1, int mouseButton, int row, int col);
		void toggle ();
	private :


		int _xLeft, _xRight, _yTop, _yBot;
		void (*_action) (layout *, int, int, int);
		unsigned int _state : 1;
		unsigned int _type : 1;

};

class layout {
	public :
		layout ();
		~layout () {}
		void setvp ();
		void resetvp ();
		void checkRegions (int x, int y, int button);
		void drawLayout ();
		void drawIcons ();
		void setColors ();
		int & bgColor () { return _bgColor;}
		int & fgColor () { return _fgColor;}
		friend void changeColor (layout *layout1, int button, int row, int col);
		friend void setThickness (layout *layout1, int button, int row, int col);
		friend void setSpray (layout *layout1, int button, int row, int col);
		friend void setShape (layout *layout1, int button, int row, int col);
		friend void editBoxClick (layout *layout1, int mouseButton, int row, int col);
		friend void toolBarClick (layout *layout1, int mouseButton, int row, int col);
		void drawThicknessBox ();
		void drawShapeBox (int color);
		void drawSprayBox ();
		void brushAndRubber (int color);
		void select ();
		void deSelect ();
		void rubber ();
		void fillColor ();
		void spray (int color);
		void pencil ();
		void brush ();
		void drawLine (int flag = 1);
		void drawCurve ();
		void drawSpiral ();
		void clip ();
		void drawRectangle (int mouseButton);
		void drawPolygon (int flag, int xi, int yi);
		void drawEllipse (int mouseButton);
		void insertText ();
		void saveFile (char *file);
		void resetCoordinates ();
		void resetSelectionCoordinates ();
		void operation (int x, int y, int button);
		void statusBarMsg (const char *message);
		void clearStatusBar ();
		int openFile (const char *fileName);
		void getInput (const char *msg, char *input, int length);
		void cut ();
		int copy ();
		void paste ();
		int translate ();
		int rotate ();
		int scale ();
		void displayFontDialog ();
		void showDialog (int x1, int y1, int x2, int y2);
		void hideDialog (int x1, int y1, int x2, int y2);
		void about ();
		void help ();
	private :

		int _layoutColor;
		int _titleBarColor;
		int _fgColor;
		int _bgColor;
		int _pattern;
		int _thickness;
		int _fillstyle;
		int _shape;    // rubber and brush
		int _spraySize;
		int _opr;
		int _font;
		int _fontSize;
		int _fontDir;
		int _shapeBoxFlag;
		int _thicknessBoxFlag;
		int _sprayBoxFlag;
		int _sx1, _sx2, _sy1, _sy2;
		int _copyWidth, _copyHeight;
		int _selected;
		int _selCol;
		int _x1, _x2, _y1, _y2;
		int _el, _et, _er, _eb; // edit box
		int _tl, _tt, _tr, _tb; // tool box
		int _sl, _st, _sr, _sb; // status
		int _cl, _ct, _cr, _cb; // color
		int _pl, _pt, _pr, _pb; // pattern
		int _Tl, _Tt, _Tr, _Tb; // title
		int _dl, _dt, _dr, _db; // drawing
		int _ql, _qt, _qr, _qb;
		int _MAXX, _MAXY;
		button _quitButton;
		button _editBox[7][2];
		button _toolBar[TOOLBARSIZE];
		button _colorBox [2][8];
		button _patternBox [2][5];
		button _thicknessBox [2]; // pencil line etc
		button _shapeBox[2][2]; // brush and rubber
		button _sprayBox[3];
		char _fileName[13];
};

void layout :: help ()
{
	int x1, x2, y1, y2;
	x1 = _MAXX / 2 - 150;
	x2 = x1 + 300;
	y1 = _MAXY / 2 - 125;
	y2 = y1 + 250;
	showDialog (x1, y1, x2, y2);
	hidemouseptr ();
	setfillstyle (SOLID_FILL, LIGHTBLUE);
	bar (x1 + 2, y1 + 2, x2 - 2, y1 + 12);
	setcolor (BLACK);
	outtextxy (x1 + 4, y1 + 4, "Help");
	button b[3];
	b[0].setProperties (x2 - 12, y1 + 2, x2 - 2, y1 + 12);
	outtextxy (x2 - 10, y1 + 4, "X");
	drawShadowBox (x1 + 20, y1 + 40, x1 + 280, y1 + 170);
	setcolor (DARKGRAY);
	line (x1 + 20, y1 + 190, x2 - 20, y1 + 190);
	setcolor (WHITE);
	line (x1 + 20, y1 + 191, x2 - 20, y1 + 191);
	b[1].setProperties (x1 + 20, y1 + 210, x1 + 120, y1 + 230);
	outtextxy (x1 + 27, y1 + 217, "<< Previous");
	b[2].setProperties (x1 + 180, y1 + 210, x1 + 280, y1 + 230);
	outtextxy (x1 + 205, y1 + 217, "Next >>");
	setcolor (RED);
	outtextxy (x1 + 20, y1 + 22, "d");
	setcolor (YELLOW);
	outtextxy (x1 + 28, y1 + 22, "Paint");
	setcolor (BLACK);
	outtextxy (x1 + 68, y1 + 22, " Help");
	showmouseptr ();
	int pages = 8, x, y;
	int curpg = 0;
	char buf[11], linebuf[35];
	int bm, xp, yp, changed = TRUE, i;
	FILE *fp;
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	while (1) {
		getmousepos (&bm, &xp, &yp);
		if (changed == TRUE) {
			sprintf (buf, "dphlp%d.txt", curpg);
			bar (x1 + 25, y1 + 45, x1 + 275, y1 + 165);
			x = x1 + 30;
			y = y1 + 45;
			fp = fopen (buf, "r");
			for (int i = 0; i < 10; i++) {
				fgets (linebuf, 35, fp);
				linebuf[strlen(linebuf) - 1] = NULL;
				hidemouseptr ();
				outtextxy (x, y, linebuf);
				showmouseptr ();
				y += 12;
			}
			fclose (fp);
		}
		changed = FALSE;
		if (bm != 0) {
			for (i = 0; i < 3; i ++)
				if (b[i].checkRegion (xp, yp)) {
					changed = TRUE;
					b[i].turnOn();
					delay (250);
					b[i].turnOff();
					switch (i) {
						case 0:
							goto endhelp;
							break;
						case 1:
							curpg --;
							if (curpg < 0) {
								curpg = 0;
								changed = FALSE;
							}
							break;
						case 2:
							curpg ++;
							if (curpg > pages - 1) {
								curpg = pages - 1;
								changed = FALSE;
							}
							break;
					}
				}
		}
	}
endhelp:
	hideDialog (x1, y1, x2, y2);
	showmouseptr ();
}
void layout :: about ()
{
	int x1, x2, y1, y2;
	x1 = _MAXX / 2 - 125;
	x2 = x1 + 250;
	y1 = _MAXY / 2 - 100;
	y2 = y1 + 150;
	showDialog (x1, y1, x2, y2);
	hidemouseptr ();
	setfillstyle (SOLID_FILL, LIGHTBLUE);
	bar (x1 + 2, y1 + 2, x2 - 2, y1 + 12);
	setcolor (BLACK);
	outtextxy (x1 + 4, y1 + 4, "About dPaint");
	button b;
	b.setProperties (x2 - 12, y1 + 2, x2 - 2, y1 + 12);
	outtextxy (x2 - 10, y1 + 4, "X");
	drawShadowBox (x1 + 30, y1 + 30, x1 + 70, y1 + 60);
	settextstyle (0, 0, 2);
	setcolor (RED);
	outtextxy (x1 + 36, y1 + 38, "d");
	setcolor (YELLOW);
	outtextxy (x1 + 52, y1 + 38, "P");
	settextstyle (0, 0, 1);
	setcolor (WHITE);
	line (x1 + 10, y1 + 86, x2 - 10, y1 + 86);
	setcolor (DARKGRAY);
	line (x1 + 10, y1 + 85, x2 - 10, y1 + 85);
	setcolor (BLACK);
	outtextxy (x1 + 120, y1 + 38, "dPaint");
	outtextxy (x1 + 20, y1 + 70, "A graphics package for dos.");
	outtextxy (x1 + 20, y1 + 95, "Coded by :");
	outtextxy (x1 + 50, y1 + 110, "Krishna Jaidev S");
	outtextxy (x1 + 50, y1 + 125, "Monish M");
	showmouseptr ();
	int bu, x, y;
	while (1) {
		getmousepos (&bu, &x, &y);
		if (bu != 0 && b.checkRegion (x, y)) {
			b.turnOn ();
			delay (250);
			break;
		}
	}
	hideDialog (x1, y1, x2, y2);
	showmouseptr ();
	resetvp ();
}


void layout :: drawSpiral ()
{
	int b = 0, x, y;
	x = _x2 = _x1;
	y = _y2 = _y1;
	int cx, cy, rx, ry;
	setwritemode (XOR_PUT);
	setcolor (_bgColor);
	setlinestyle (DOTTED_LINE, 0, 1);
	do {
		getmousepos (&b, &x, &y);
		x -= _dl, y -= _dt;
		if (x != _x2 || y != _y2) {
			hidemouseptr ();
			line (_x1, _y1, _x2, _y2);
			line (_x1, _y1, x, y);
			showmouseptr ();
			_x2 = x;
			_y2 = y;
		}
	} while (b == 1 || b == 2);
	_x2 = x;
	_y2 = y;

	rx = sqrt (abs ((_x1 - _x2) * (_x1 - _x2) + (_y1 - _y2) * (_y1 - _y2)));
	hidemouseptr();
	line (_x1, _y1, _x2, _y2);
	setcolor (_fgColor);
	setwritemode (COPY_PUT);
	int i;
	for (i = 0; i < rx; i += 5) {
		arc( _x1, _y1, 0, 180, i);
		arc( _x1 + 2, _y1, 180, 270, i+2);
		arc( _x1 + 3, _y1, 270, 360, i+2);
	}

	showmouseptr ();


}
void layout :: clip ()
{
	_editBox[0][0].turnOff ();
	_opr = NONE;
	if (_sx1 == _sx2) {
		statusBarMsg ("Select region first.");
		return;
	}

	setvp ();
	deSelect ();
	int x1, y1, x2, y2;
	x1 = (_sx1 > _sx2) ? _sx2 : _sx1;
	x2 = (_sx1 > _sx2) ? _sx1 : _sx2;
	y1 = (_sy1 > _sy2) ? _sy2 : _sy1;
	y2 = (_sy1 > _sy2) ? _sy1 : _sy2;

	x1 += _dl;
	x2 += _dl;
	y1 += _dt;
	y2 += _dt;

	setfillstyle (SOLID_FILL, _bgColor);
	hidemouseptr ();
	resetvp ();
	bar (_dl + 1, _dt + 1, x1 - 1, _db - 1);
	bar (_dl + 1, _dt + 1, _dr - 1, y1 - 1);
	bar (_dr - 1, _dt + 1, x2 + 1, _db - 1);
	bar (_dl + 1, y2 + 1, _dr - 1, _db - 1);
	showmouseptr ();
	resetSelectionCoordinates ();
}

void layout :: displayFontDialog ()
{
	int i, j;
	int x1, x2, y1, y2;
	x1 = _MAXX / 2 - 125;
	x2 = x1 + 250;
	y1 = _MAXY / 2 - 100;
	y2 = y1 + 150;
	showDialog (x1, y1, x2, y2);
	hidemouseptr ();
	setfillstyle (SOLID_FILL, LIGHTBLUE);
	bar (x1 + 2, y1 + 2, x2 - 2, y1 + 12);
	setcolor (BLACK);
	outtextxy (x1 + 4, y1 + 4, "Font Properties");
	button b[6];

	b[0].setProperties (x1 + 40, y1 + 122, x1 + 110, y1 + 137);
	outtextxy (x1 + 67, y1 + 126, "OK");
	b[1].setProperties (x2 - 110, y1 + 122, x2 - 40, y1 + 137);
	outtextxy (x2 - 97, y1 + 126, "CANCEL");
	b[2].setProperties (x2 - 12, y1 + 2, x2 - 2, y1 + 12);
	outtextxy (x2 - 10, y1 + 4, "X");
	outtextxy (x1 + 10, y1 + 22, "Font");
	b[3].setProperties (x1 + 50, y1 + 17, x1 + 140, y1 + 34);
	outtextxy (x1 + 10, y1 + 45, "Size");
	b[4].setProperties (x1 + 50, y1 + 40, x1 + 75, y1 + 57);
	b[5].setProperties (x1 + 99, y1 + 46, x1 + 106, y1 + 53, TOGGLE);
	outtextxy (x1 + 110, y1 + 45, "Horizontal");
//	outtextxy (x1 + 30, y1 + 65, "Preview");
	drawShadowBox (x1 + 30, y1 + 70, x2 - 30, y1 + 110);
	int font = _font, size = _fontSize, dir = _fontDir;
	int butt, xp, yp;
	char *fname[] = { "DEFAULT",
		  "TRIPLEX",
		  "SMALL",
		  "SANS SERIF",
		  "GOTHIC"
		};
	char *sname[] = { "1x", "2x", "3x"};

	int changed = TRUE;
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	if (dir == HORIZ_DIR)
		b[5].turnOn ();
	showmouseptr ();
	while (1) {
		getmousepos (&butt, &xp, &yp);
		if (changed) {
			setcolor (BLACK);
			hidemouseptr ();
			bar (x1 + 52, y1 + 20, x1 + 138, y1 + 30);
			bar (x1 + 52, y1 + 42, x1 + 70, y1 + 55);
			outtextxy (x1 + 55, y1 + 22, fname[font]);
			outtextxy (x1 + 55, y1 + 45, sname[size - 1]);
			bar (x1 + 32, y1 + 72, x2 - 32, y1 + 108);
			settextstyle (font, 0, size);
			outtextxy (x1 + 35, y1 + 75, "Sample");
			settextstyle (0, 0, 1);
			showmouseptr ();
		}
		changed = FALSE;
		if (butt != 0) {
			for (i = 0; i < 6; i++)
				if (b[i].checkRegion (xp, yp)) {
					if (i != 5) {
						b[i].turnOn ();
						delay (250);
					}
					changed = TRUE;
					switch (i) {
						case 0: // OK
							_font = font;
							_fontSize = size;
							_fontDir = dir;
						case 1: //CANCEL
						case 2: // QUIT
							goto outofloop;
						case 3: // FONT
							font ++;
							if (font > 4) font = 0;
							break;
						case 4: // SIZE
							size ++;
							if (size > 3)
								size = 1;
							break;
						case 5: // DIR
							delay (250);
							if (dir == HORIZ_DIR) {
								b[5].turnOff ();
								dir = VERT_DIR;
							}
							else {
								dir = HORIZ_DIR;
								b[5].turnOn ();
							}
							break;
					}
					if (i != 5)
						b[i].turnOff ();
				}
		}
	}
outofloop :
	hideDialog (x1, y1, x2, y2);
}
void layout :: showDialog (int x1, int y1, int x2, int y2)
{
	int i, j;
	FILE *fp = fopen ("tempbuf.dpi", "wb");
	hidemouseptr ();
	for (j = y1; j <= y2; j++)
		for (i = x1; i <= x2; i++)
			fputc (getpixel (i, j), fp);
	fclose (fp);
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	bar (x1, y1, x2, y2);
	setcolor (DARKGRAY);
	setlinestyle (SOLID_LINE, 0, 1);
	drawShadowBox (x1 + 1, y1 + 1, x2 - 1, y2 - 1, 0);
	showmouseptr ();
}
void layout :: hideDialog (int x1, int y1, int x2, int y2)
{
	hidemouseptr ();
	int i, j;
	FILE * fp = fopen ("tempbuf.dpi", "rb");
	for (j = y1; j <= y2; j++)
		for (i = x1; i <= x2; i++)
			putpixel (i, j, fgetc (fp));
	fclose (fp);
	showmouseptr ();
}

int layout :: translate  ()
{
	_editBox[0][0].turnOff ();
	_opr = NONE;
	if (_sx1 == _sx2) {
		statusBarMsg ("Select region first.");
		return 0;
	}
	setvp ();
	deSelect ();

	FILE *fp = fopen ("transbuf.dpi", "wb");
	int xt1, yt1, xt2, yt2, x, y, x1, y1, x2, y2;
	xt1 = (_sx1 > _sx2) ? _sx2 : _sx1;
	xt2 = (_sx1 > _sx2) ? _sx1 : _sx2;
	yt1 = (_sy1 > _sy2) ? _sy2 : _sy1;
	yt2 = (_sy1 > _sy2) ? _sy1 : _sy2;

	int height = yt2 - yt1;
	int width = xt2 - xt1;

	hidemouseptr ();
	for (int j = yt1; j <= yt2; j++)
		for (int i = xt1; i <= xt2; i++)
			fputc (getpixel (i, j), fp);
	showmouseptr ();
	fclose (fp);
	resetvp ();

	x1 = _MAXX / 2 - 125;
	x2 = x1 + 250;
	y1 = _MAXY / 2 - 100;
	y2 = y1 + 130;
	showDialog (x1, y1, x2, y2);
	hidemouseptr ();
	button b[11];
	setfillstyle (SOLID_FILL, LIGHTBLUE);
	bar (x1 + 2, y1 + 2, x2 - 2, y1 + 12);
	setcolor (BLACK);
	outtextxy (x1 + 4, y1 + 4, "Translate");
	b[0].setProperties (x1 + 40, y1 + 102, x1 + 110, y1 + 117);
	outtextxy (x1 + 67, y1 + 106, "OK");
	b[1].setProperties (x2 - 110, y1 + 102, x2 - 40, y1 + 117);
	outtextxy (x2 - 97, y1 + 106, "CANCEL");
	b[2].setProperties (x2 - 12, y1 + 2, x2 - 2, y1 + 12);
	outtextxy (x2 - 10, y1 + 4, "X");
	outtextxy (x1 + 25, y1 + 32, "X increment");
	b[7].setProperties (x1 + 115, y1 + 30, x1 + 135, y1 + 40);
	b[3].setProperties (x1 + 140, y1 + 30, x1 + 150, y1 + 40);
	outtextxy (x1 + 142, y1 + 32, "<");
	outtextxy (x1 + 117, y1 + 32, "<<");
	b[4].setProperties (x1 + 185, y1 + 30, x1 + 195, y1 + 40);
	b[8].setProperties (x1 + 200, y1 + 30, x1 + 220, y1 + 40);
	outtextxy (x1 + 187, y1 + 32, ">");
	outtextxy (x1 + 202, y1 + 32, ">>");

	outtextxy (x1 + 25, y1 + 62, "Y increment");
	b[5].setProperties (x1 + 140, y1 + 60, x1 + 150, y1 + 70);
	b[9].setProperties (x1 + 115, y1 + 60, x1 + 135, y1 + 70);
	outtextxy (x1 + 142, y1 + 62, "<");
	outtextxy (x1 + 117, y1 + 62, "<<");
	b[6].setProperties (x1 + 185, y1 + 60, x1 + 195, y1 + 70);
	b[10].setProperties (x1 + 200, y1 + 60, x1 + 220, y1 + 70);
	outtextxy (x1 + 202, y1 + 62, ">>");
	outtextxy (x1 + 187, y1 + 62, ">");
	setcolor (WHITE);
	line (x1 + 20, y1 + 91, x2 - 20, y1 + 91);
	setcolor (DARKGRAY);
	line (x1 + 20, y1 + 90, x2 - 20, y1 + 90);
	setcolor (BLACK);
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	showmouseptr ();
	int incrx = 0, incry = 0, bm, xp, yp, changed = TRUE;

	char valx[4], valy[4];
	valx[3] = valy[3] = NULL;
	while (1) {
		getmousepos (&bm, &xp, &yp);
		if (changed) {
			if (incrx > 99)
				incrx = 99;
			else if (incrx < -99)
				incrx = -99;
			if (incry > 99)
				incry = 99;
			else if (incry < -99)
				incry = -99;
			hidemouseptr ();
			bar (x1 + 155, y1 + 30, x1 + 184, y1 + 40);
			bar (x1 + 155, y1 + 60, x1 + 184, y1 + 70);
			if (incrx < 0)
				valx[0] = '-';
			else
				valx [0] = '+';
			valx[1] = abs (incrx) / 10 + '0';
			valx[2] = abs (incrx) % 10 + '0';
			outtextxy (x1 + 155, y1 + 32, valx);
			if (incry < 0)
				valy[0] = '-';
			else
				valy[0] = '+';
			valy [1] = abs (incry) / 10 + '0';
			valy [2] = abs (incry) % 10 + '0';
			valy [3] = NULL;
			outtextxy (x1 + 155, y1 + 62, valy);
			showmouseptr ();
		}
		changed = FALSE;
		if (bm != 0) {
			for (i = 0; i < 11; i ++)
				if (b[i].checkRegion (xp, yp)) {
					changed = TRUE;
					b[i].turnOn ();
					delay (150);
					switch (i) {
						case 0: // OK
						case 1: // CANCEL
						case 2 : // QUIT
							goto outside;
						case 3 : // DECX
							incrx --;
							break;
						case 4: // INCX
							incrx ++;
							break;
						case 5: // DECY
							incry --;
							break;
						case 6: // INCY
							incry ++;
							break;
						case 7:
							incrx -= 10;
							break;
						case 8:
							incrx += 10;
							break;
						case 9:
							incry -= 10;
							break;
						case 10:
							incry += 10;
							break;
					}
					b[i].turnOff ();
				}
		} // end if (bm != 0)
	}
outside :
	hideDialog (x1, y1, x2, y2);
	if (i == 0) {
		setvp ();
		fp = fopen ("transbuf.dpi", "rb");
		hidemouseptr ();
		setfillstyle (SOLID_FILL, _bgColor);
		bar (xt1, yt1, xt2, yt2);
		int x = xt1 + incrx, y = yt1 - incry;
		for (j = y; j <= y + height; j++)
			for (i = x; i <= x + width; i ++)
				putpixel (i, j, fgetc (fp));
		showmouseptr ();
		fclose (fp);
		resetvp ();
	}
	resetSelectionCoordinates ();
	return 1;
}
int layout :: rotate ()
{
	_editBox[0][0].turnOff ();
	_opr = NONE;
	if (_sx1 == _sx2) {
		statusBarMsg ("Select region first.");
		return 0;
	}
	setvp ();
	deSelect ();
	FILE *fp = fopen ("transbuf.dpi", "wb");
	int xt1, yt1, xt2, yt2, x, y, x1, y1, x2, y2;
	xt1 = (_sx1 > _sx2) ? _sx2 : _sx1;
	xt2 = (_sx1 > _sx2) ? _sx1 : _sx2;
	yt1 = (_sy1 > _sy2) ? _sy2 : _sy1;
	yt2 = (_sy1 > _sy2) ? _sy1 : _sy2;

	hidemouseptr ();
	for (int j = yt1; j <= yt2; j++)
		for (int i = xt1; i <= xt2; i++)
			fputc (getpixel (i, j), fp);
	showmouseptr ();
	fclose (fp);
	resetvp ();

	x1 = _MAXX / 2 - 125;
	x2 = x1 + 250;
	y1 = _MAXY / 2 - 100;
	y2 = y1 + 130;
	showDialog (x1, y1, x2, y2);
	hidemouseptr ();
	button b[8];
	setfillstyle (SOLID_FILL, LIGHTBLUE);
	bar (x1 + 2, y1 + 2, x2 - 2, y1 + 12);
	setcolor (BLACK);
	outtextxy (x1 + 4, y1 + 4, "Rotate");
	b[0].setProperties (x1 + 40, y1 + 102, x1 + 110, y1 + 117);
	outtextxy (x1 + 67, y1 + 106, "OK");
	b[1].setProperties (x2 - 110, y1 + 102, x2 - 40, y1 + 117);
	outtextxy (x2 - 97, y1 + 106, "CANCEL");
	b[2].setProperties (x2 - 12, y1 + 2, x2 - 2, y1 + 12);
	outtextxy (x2 - 10, y1 + 4, "X");
	outtextxy (x1 + 50, y1 + 32, "Angle");
	b[3].setProperties (x1 + 140, y1 + 30, x1 + 150, y1 + 40);
	outtextxy (x1 + 142, y1 + 32, "<");
	b[7].setProperties (x1 + 115, y1 + 30, x1 + 135, y1 + 40);
	outtextxy (x1 + 117, y1 + 32, "<<");
	b[4].setProperties (x1 + 185, y1 + 30, x1 + 195, y1 + 40);
	outtextxy (x1 + 187, y1 + 32, ">");
	b[6].setProperties (x1 + 200, y1 + 30, x1 + 220, y1 + 40);
	outtextxy (x1 + 202, y1 + 32, ">>");
	outtextxy (x1 + 65, y1 + 60, "Counter-clockwise");
	b[5].setProperties (x1 + 50, y1 + 60, x1 + 57, y1 + 67, TOGGLE, ON);

	setcolor (WHITE);
	line (x1 + 20, y1 + 91, x2 - 20, y1 + 91);
	setcolor (DARKGRAY);
	line (x1 + 20, y1 + 90, x2 - 20, y1 + 90);
	showmouseptr ();
	int angle = 0, bm, xp, yp, changed = TRUE, dir = 0;
	char ang[4];
	setcolor (BLACK);
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	ang[3] = NULL;
	while (1) {
		if (changed == TRUE) {
			if (angle > 360)
				angle = 360;
			else if (angle < 0)
				angle = 0;
			hidemouseptr ();
			bar (x1 + 155, y1 + 30, x1 + 184, y1 + 40);
			ang[0] = angle / 100 + '0';
			ang[1] = (angle - (ang[0] - '0') * 100) / 10 + '0';
			ang [2] = angle % 10 + '0';
			setcolor (BLACK);
			outtextxy (x1 + 155, y1 + 32, ang);
			showmouseptr ();
		}
		getmousepos (&bm, &xp, &yp);
		changed = FALSE;
		if (bm != 0) {
			for (i = 0; i < 8; i++)
				if (b[i].checkRegion(xp, yp)) {
					changed = TRUE;
					if (i != 5) {
						b[i].turnOn ();
						delay (150);
						b[i].turnOff ();
					}
					switch (i) {
						case 0:
						case 1:
						case 2:
							goto outsideloop;
						case 3:
							angle --;
							break;
						case 4:
							angle ++;
							break;
						case 5:
							b[5].toggle ();
							delay (250);
							if (dir)
								dir = 0;
							else dir = 1;
							break;
						case 6:
							angle += 10;
							break;
						case 7:
							angle -= 10;
							break;
					}

				}
		}
	}
outsideloop:
	hideDialog (x1, y1, x2, y2);
	if (i == 0) {
		setvp ();
		fp = fopen ("transbuf.dpi", "rb");
		hidemouseptr ();
		setfillstyle (SOLID_FILL, _bgColor);
		bar (xt1, yt1, xt2, yt2);
		if (dir)
			angle = -angle;
		float an;
		an = float (angle) * M_PI / 180;
		float cosa = cos (an);
		float sina = sin (an);
		float newx, newy, x, y;
		int pix;
		for (j = yt1; j <= yt2; j++)
			for (i = xt1; i <= xt2; i ++) {
				x = i - xt1;
				y = abs (j - yt2);
				newx = float (x) * cosa - y * sina;
				newy = float (x) * sina + y * cosa;
				x = newx + xt1;
				y = yt2 - newy;
				pix = fgetc (fp);
//				putpixel (i, j, pix);
				putpixel (x, y, pix);

			}
		showmouseptr ();
		fclose (fp);
		resetvp ();
	}
	resetSelectionCoordinates ();
	return 1;
}

int layout :: scale ()
{
	_editBox[0][0].turnOff ();
	_opr = NONE;
	if (_sx1 == _sx2) {
		statusBarMsg ("Select region first.");
		return 0;
	}
	setvp ();
	deSelect ();
	FILE *fp = fopen ("transbuf.dpi", "wb");
	int xt1, yt1, xt2, yt2, x, y, x1, y1, x2, y2;
	xt1 = (_sx1 > _sx2) ? _sx2 : _sx1;
	xt2 = (_sx1 > _sx2) ? _sx1 : _sx2;
	yt1 = (_sy1 > _sy2) ? _sy2 : _sy1;
	yt2 = (_sy1 > _sy2) ? _sy1 : _sy2;

	hidemouseptr ();
	for (int j = yt1; j <= yt2; j++)
		for (int i = xt1; i <= xt2; i++)
			fputc (getpixel (i, j), fp);
	showmouseptr ();
	resetvp ();
	fclose (fp);

	x1 = _MAXX / 2 - 125;
	x2 = x1 + 250;
	y1 = _MAXY / 2 - 100;
	y2 = y1 + 130;
	showDialog (x1, y1, x2, y2);
	hidemouseptr ();
	button b[7];
	setfillstyle (SOLID_FILL, LIGHTBLUE);
	bar (x1 + 2, y1 + 2, x2 - 2, y1 + 12);
	setcolor (BLACK);
	outtextxy (x1 + 4, y1 + 4, "Scale");
	b[0].setProperties (x1 + 40, y1 + 102, x1 + 110, y1 + 117);
	outtextxy (x1 + 67, y1 + 106, "OK");
	b[1].setProperties (x2 - 110, y1 + 102, x2 - 40, y1 + 117);
	outtextxy (x2 - 97, y1 + 106, "CANCEL");
	b[2].setProperties (x2 - 12, y1 + 2, x2 - 2, y1 + 12);
	outtextxy (x2 - 10, y1 + 4, "X");
	outtextxy (x1 + 25, y1 + 32, "X Scale");
	b[3].setProperties (x1 + 140, y1 + 30, x1 + 150, y1 + 40);
	outtextxy (x1 + 142, y1 + 32, "<");
	b[4].setProperties (x1 + 195, y1 + 30, x1 + 205, y1 + 40);
	outtextxy (x1 + 197, y1 + 32, ">");

	outtextxy (x1 + 25, y1 + 62, "Y Scale");
	b[5].setProperties (x1 + 140, y1 + 60, x1 + 150, y1 + 70);
	outtextxy (x1 + 142, y1 + 62, "<");
	b[6].setProperties (x1 + 195, y1 + 60, x1 + 205, y1 + 70);
	outtextxy (x1 + 197, y1 + 62, ">");
	setcolor (WHITE);
	line (x1 + 20, y1 + 91, x2 - 20, y1 + 91);
	setcolor (DARKGRAY);
	line (x1 + 20, y1 + 90, x2 - 20, y1 + 90);

	int bm, xp, yp, changed = TRUE;
	float sx = 1.0, sy = 1.0;
	char scx[5], scy[5];
	scx[4] = scy[4] = NULL;
	scx[1] = scy[1] = '.';
	showmouseptr ();
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	while (1) {
		getmousepos (&bm, &xp, &yp);
		if (changed == TRUE) {
			if (sx > 5)
				sx = 5;
			else if (sx < 1)
				sx = 1.00;
			if (sy > 5)
				sy = 5;
			else if (sy < 1)
				sy = 1.00;
			scx[0] = int (sx) % 10 + '0';
			scy[0] = int (sy) % 10 + '0';
			scx[2] = int (sx * 10) % 10 + '0';
			scy[2] = int (sy * 10) % 10 + '0';
			scx [3] = int (sx * 100) % 10 + '0';
			scy [3] = int (sy * 100) % 10 + '0';
			hidemouseptr ();
			bar (x1 + 155, y1 + 30, x1 + 192, y1 + 40);
			bar (x1 + 155, y1 + 60, x1 + 192, y1 + 70);
			setcolor (BLACK);
			outtextxy (x1 + 157, y1 + 32, scx);
			outtextxy (x1 + 157, y1 + 62, scy);
			showmouseptr ();
		}
		changed = FALSE;
		if (bm != 0) {
			for (i = 0; i < 7; i ++)
				if (b[i].checkRegion (xp, yp)) {
					changed = TRUE;
					b[i].turnOn ();
					delay (150);
					b[i].turnOff ();
					switch (i) {
						case 0:
						case 1:
						case 2:
							goto here;
						case 3:
							sx -= 0.25;
							break;
						case 4:
							sx += 0.25;
							break;
						case 5:
							sy -= 0.25;
							break;
						case 6:
							sy += 0.25;
							break;
					}
				}
		}
	}
here :
	hideDialog (x1, y1, x2, y2);
	if (i == 0) {
		setvp ();
		fp = fopen ("transbuf.dpi", "rb");
		hidemouseptr ();
		setfillstyle (SOLID_FILL, _bgColor);
		bar (xt1, yt1, xt2, yt2);
		int k, l, pix, x, ym;
		float newx, newy;
		for (j = yt1; j <= yt2; j ++)
			for (i = xt1; i <= xt2; i++) {
				pix = fgetc (fp);
				x = i - xt1;
				y = abs (j - yt2);
				newx = float (x) * sx;
				newx += xt1;
				for (k = 1; k <= sx; k++) {
					newy = float (y) * sy;
					newy = yt2 - newy;
					for (l = 1; l <= sy; l ++) {
						putpixel (floor (newx), ceil (newy), pix);
						putpixel (floor (newx), floor (newy), pix);
						putpixel (ceil (newx), floor (newy), pix);
						putpixel (ceil (newx), ceil (newy), pix);
						newy ++;
					}
					newx ++;
				}
			}
	}

	showmouseptr ();
	resetvp ();
	resetSelectionCoordinates ();
	return 1;
}
void layout :: cut ()
{
	if (!copy ()) {
		return;
	}
	setfillstyle (SOLID_FILL,_bgColor);
	setvp ();
	bar (_sx1, _sy1, _sx2, _sy2);
	resetvp ();
}

int layout :: copy ()
{
	_editBox[0][0].turnOff ();
	_opr = NONE;
	if (_sx1 == _sx2) {
		statusBarMsg ("Select region first.");
		return 0;
	}
	setvp ();
	deSelect ();
	FILE *fp = fopen ("copybuf.dpi", "wb");
	int x1, y1, x2, y2;
	x1 = (_sx1 > _sx2) ? _sx2 : _sx1;
	x2 = (_sx1 > _sx2) ? _sx1 : _sx2;
	y1 = (_sy1 > _sy2) ? _sy2 : _sy1;
	y2 = (_sy1 > _sy2) ? _sy1 : _sy2;

	_copyHeight = y2 - y1;
	_copyWidth = x2 - x1;

	hidemouseptr ();
	for (int j = y1; j <= y2; j++)
		for (int i = x1; i <= x2; i++)
			fputc (getpixel (i, j), fp);
	showmouseptr ();
	fclose (fp);
	resetvp ();
	return 1;
}

void layout :: paste ()
{
	setvp ();
	deSelect ();
	resetSelectionCoordinates ();
	resetvp ();
	if (access ("copybuf.dpi", 00) != 0) {
		statusBarMsg ("Nothing to paste.");
		return;
	}
	statusBarMsg ("Click on location");
	setvp ();
	FILE *fp = fopen ("copybuf.dpi", "rb");
	int b = 0, x, y;
	do
		getmousepos (&b, &x, &y);
	while (b == 0);
	x -= _dl;
	y -= _dt;
	hidemouseptr ();
	for (int j = y; j <= y + _copyHeight; j++)
		for (int i = x; i <= x + _copyWidth; i ++)
			putpixel (i, j, fgetc (fp));
	showmouseptr ();
	fclose (fp);
	resetvp ();
}

void setShape (layout *layout1, int button, int row, int col)
{
	for (int i = 0; i < 2; i++)
		for (int j = 0; j < 2; j ++)
			if (i != row || j != col)
				layout1->_shapeBox[i][j].turnOff ();
	layout1->_shape = row * 2 + col;
}

void layout :: resetSelectionCoordinates ()
{
	_sx1 = _sx2 = _sy1 = _sy2 = -1;
}
void layout :: resetCoordinates ()
{
	_x1 = _x2 = _y1 = _y2 = -1;
}

void layout :: select ()
{
	int b = 0, x, y;
	if (_selected == TRUE)
		deSelect ();
	_selected = TRUE;
	x = _sx2 = _sx1 = _x1;
	y = _sy2 = _sy1 = _y1;
//	int cx, cy, rx, ry;
	setwritemode (XOR_PUT);
	if (_bgColor) {
		setcolor (_bgColor);
		_selCol = _bgColor;
	}
	else {
		setcolor (YELLOW);
		_selCol = YELLOW;
	}
	setlinestyle (DOTTED_LINE, 0, 1);
	do {
		getmousepos (&b, &x, &y);
		x -= _dl, y -= _dt;
		if (x != _sx2 || y != _sy2) {
			hidemouseptr ();
			rectangle (_sx1, _sy1, _sx2, _sy2);
			rectangle (_sx1, _sy1, x, y);
			showmouseptr ();
			_sx2 = x;
			_sy2 = y;
		}
	} while	(b == 1 || b == 2);
	setwritemode (COPY_PUT);
	setcolor (_fgColor);
	setlinestyle (SOLID_LINE, 0, 1);
	resetvp ();
}
void layout :: brushAndRubber (int color)
{
	int b = 0, radius = 0, width = 0, x1, y1, x2, y2, incy = 1, d, tx, ty, flag = 0;
	_x2 = _x1;
	_y2 = _y1;
	int dx, dy;
	setcolor (color);
	setfillstyle (SOLID_FILL, color);
	do {
		flag = 0;
		incy = 1;
		hidemouseptr ();
		switch (_shape) {
			case SMALLCIRCLE:
			case BIGCIRCLE:
				radius = _shape * 2 + 2;
				break;
			case SMALLSQUARE:
				width = 1;
				break;
			case BIGSQUARE:
				width = 2;
				break;
		}
		dx = abs (_x1 - _x2);
		dy = abs (_y1 - _y2);
		x1 = _x1;
		y1 = _y1;
		x2 = _x2;
		y2 = _y2;
		if (dy > dx) {
			swap (x1, y1);
			swap (x2, y2);
			swap (dx, dy);
			flag = 1;
		}
		if(x1 > x2) {
			swap (x1, x2);
			swap (y1, y2);
		}
		if (y1 > y2)
			incy = -1;
		d = 2 * dy - dx;
		while (x1 <= x2) {
			if (flag) {
				if (_shape == SMALLCIRCLE || _shape == BIGCIRCLE)
					fillellipse (y1, x1, radius, radius);
				else
					bar (y1 - width, x1 - width, y1 + width, x1 + width);
			}
			else {
				if (_shape == SMALLCIRCLE || _shape == BIGCIRCLE)
					fillellipse (x1, y1, radius, radius);
				else
					bar (x1 - width, y1 - width, x1 + width, y1 + width);
			}
			if(d < 0)
				d += 2 * dy;
			else {
				d += 2 * (dy - dx);
				y1 += incy;
			}
			x1++;
		}
		showmouseptr ();
		_x1 = _x2;
		_y1 = _y2;
		getmousepos (&b, &_x2, &_y2);
		_x2 -= _dl;
		_y2 -= _dt;
	} while (b == 1 || b == 2);
}

void layout :: rubber ()
{
	brushAndRubber (_bgColor);
}

void layout :: brush ()
{
	brushAndRubber (_fgColor);
}
void layout :: fillColor ()
{
	pointQueue q;
	hidemouseptr ();
	int x, y, color;
	color = getpixel (_x1, _y1);
	if (color == _fgColor) {
		showmouseptr ();
		return;
	}
	q.add (_x1, _y1);
	while (!q.empty ()) {
		q.remove (x, y);
		if (getpixel (x, y) == color) {
			putpixel (x, y, _fgColor);
			q.add (x, y + 1);
			q.add (x, y - 1);
			q.add (x + 1, y);
			q.add (x - 1, y);
		}
	}
	showmouseptr ();

}

int withinCircle (int cx, int cy, int radius, int x, int y)
{
	int LHS = (x - cx) * (x - cx) + (y - cy) * (y - cy);
	int RHS = radius * radius;
	if (LHS <= RHS)
		return 1;
	else
		return 0;

}
void layout :: spray (int color)
{
	int radius = 4, flag = 1;
	static int order = 1;
	if (_spraySize == 1)
		radius = 6;
	else if (_spraySize == 2)
		radius = 8;
	pointQueue q;
	int x, y, b;
	q.add (_x1, _y1);

	while (!q.empty ()) {
		q.remove (x, y);
		if (withinCircle (_x1, _y1, radius, x, y)) {
			hidemouseptr ();
			if (flag) {
				flag = 0;
				putpixel (x, y, color);
			}
			else
				flag = 1;
			showmouseptr ();
			radius ++;
			if (order == 1) {
				q.add (x + random (radius), y + random (radius));
				q.add (x - random (radius), y - random (radius));
				q.add (x + random (radius), y - random (radius));
				q.add (x - random (radius), y + random (radius));
				order = 2;
			}
			else if (order == 2) {
				q.add (x - random (radius), y - random (radius));
				q.add (x + random (radius), y + random (radius));
				q.add (x - random (radius), y + random (radius));
				q.add (x + random (radius), y - random (radius));

				order = 3;
			}
			else if (order == 3) {
				q.add (x - random (radius), y + random (radius));
				q.add (x + random (radius), y - random (radius));
				q.add (x - random (radius), y - random (radius));
				q.add (x + random (radius), y + random (radius));
				order = 4;
			}
			else {
				q.add (x + random (radius), y - random (radius));
				q.add (x - random (radius), y + random (radius));
				q.add (x + random (radius), y + random (radius));
				q.add (x - random (radius), y - random (radius));
				order = 1;
			}
			radius --;

		}
		else return;
	}
}


void layout :: pencil ()
{
	int b = 0;
	_x2 = _x1;
	_y2 = _y1;
	setcolor (_fgColor);
	setlinestyle (SOLID_LINE, 0, _thickness);
	putpixel (_x1, _y1, _fgColor);
	do {
		getmousepos (&b, &_x2, &_y2);
		_x2 -= _dl;
		_y2 -= _dt;
		if (_x1 != _x2 || _y1 != _y2) {
			hidemouseptr ();
			line (_x1, _y1, _x2, _y2);
			showmouseptr ();
			_x1 = _x2;
			_y1 = _y2;
		}
	} while (b == 1 || b == 2);

}

void layout :: drawLine (int flag)
{
	int b = 0, x, y;
	x = _x2 = _x1;
	y = _y2 = _y1;
	if (flag) {
		setwritemode (XOR_PUT);
		if (_bgColor)
			setcolor (_bgColor);
		else
			setcolor (YELLOW);
	}
	else setcolor (_fgColor);
	setlinestyle (SOLID_LINE, 0, _thickness);
	do {
		getmousepos (&b, &x, &y);
		x -= _dl;
		y -= _dt;
		if (x != _x2 || y != _y2) {
			hidemouseptr ();
			if (flag)
				line (_x1, _y1, _x2, _y2);
			line (_x1, _y1, x, y);
			showmouseptr ();
			_x2 = x;
			_y2 = y;
		}
	} while (b == 1 || b == 2);
	_x2 = x;
	_y2 = y;
	setcolor (_fgColor);
	if (flag) {
		setwritemode (COPY_PUT);
		hidemouseptr ();
		line (_x1, _y1, _x2, _y2);
	}
	showmouseptr ();
}

void layout :: drawCurve ()
{
	setvp ();
	int b = 0, x, y;
	do
		getmousepos (&b, &_x1, &_y1);
	while (b == 0);
	_x1 -= _dl;
	_y1 -= _dt;
	x = _x2 = _x1;
	y = _y2 = _y1;
	int i, j;
	FILE *fp;
	setwritemode (XOR_PUT);
	if (_bgColor)
		setcolor (_bgColor);
	else
		setcolor (YELLOW);
	setlinestyle (SOLID_LINE, 0, _thickness);
	do {
		getmousepos (&b, &x, &y);
		x -= _dl;
		y -= _dt;
		if (x != _x2 || y != _y2) {
			hidemouseptr ();
			line (_x1, _y1, _x2, _y2);
			line (_x1, _y1, x, y);
			showmouseptr ();
			_x2 = x;
			_y2 = y;
		}
	} while (b == 1 || b == 2);
	int x3, y3, x4 = _x2, y4 = _y2;
	while (b == 1)
		getmousepos (&b, &x, &y);
	do {
		getmousepos (&b, &x, &y);
	} while (b != 1);
	x3 = _x2 = x -= _dl;
	y3 = _y2 = y -= _dt;
	float xt, yt, t;
	hidemouseptr ();
	line (_x1, _y1, x4, y4);
	for(t = 0; t < 1; t += 0.0005) {
		xt = (1-t)*(1-t)*(1-t)* _x1 + 3*t*(1-t)*(1-t)* _x2
			+ 3*t*t*(1-t)*x3 + t*t*t*x4;
		yt = (1-t)*(1-t)*(1-t)* _y1 + 3*t*(1-t)*(1-t)* _y2
				+ 3*t*t*(1 - t)*y3 + t*t*t*y4;
		putpixel(xt, yt, _fgColor);
		if (_thickness == 3) {
			putpixel (xt + 1, yt + 1, _fgColor);
			putpixel (xt - 1, yt - 1, _fgColor);
			putpixel (xt - 1, yt + 1, _fgColor);
			putpixel (xt + 1, yt - 1, _fgColor);
		}
	}
	showmouseptr ();

	while (b == 1)
		getmousepos (&b, &x, &y);
	do {
		getmousepos (&b, &x, &y);
	} while (b != 1);
	x3 = x - _dl;
	y3 = y - _dt;
	hidemouseptr ();
/*	for(t = 0; t < 1; t += 0.0005) {
		xt = (1-t)*(1-t)*(1-t)* _x1 + 3*t*(1-t)*(1-t)* _x2
			+ 3*t*t*(1-t)*oldx + t*t*t*x4;
		yt = (1-t)*(1-t)*(1-t)* _y1 + 3*t*(1-t)*(1-t)* _y2
				+ 3*t*t*(1 - t)*oldy + t*t*t*y4;
		putpixel(xt - _dl,yt - _dt, _bgColor);
		if (_thickness == 3) {
			putpixel (xt - _dl + 1, yt - _dt + 1, _bgColor);
			putpixel (xt - _dl - 1, yt - _dt - 1, _bgColor);
			putpixel (xt - _dl - 1, yt - _dt + 1, _bgColor);
			putpixel (xt - _dl + 1, yt - _dt - 1, _bgColor);
		}
	}*/
	openFile ("temp.dpi");
	fclose (fp);

//	line (_x1 - _dl, _y1 - _dt, x4 - _dl, y4 - _dt);
	setcolor (_fgColor);
	setwritemode (COPY_PUT);
	for(t = 0; t < 1; t += 0.0005) {
		xt = (1-t)*(1-t)*(1-t)* _x1 + 3*t*(1-t)*(1-t)* _x2
			+ 3*t*t*(1-t)*x3 + t*t*t*x4;
		yt = (1-t)*(1-t)*(1-t)* _y1 + 3*t*(1-t)*(1-t)* _y2
				+ 3*t*t*(1 - t)*y3 + t*t*t*y4;
		putpixel(xt, yt, _fgColor);
		if (_thickness == 3) {
			putpixel (xt + 1, yt + 1, _fgColor);
			putpixel (xt - 1, yt - 1, _fgColor);
			putpixel (xt - 1, yt + 1, _fgColor);
			putpixel (xt + 1, yt - 1, _fgColor);
		}
	}
	while (b == 1)
		getmousepos (&b, &x, &y);
	showmouseptr ();
	resetvp ();
	_editBox[3][1].turnOff();
	_opr = NONE;
}

void layout :: drawRectangle (int mouseButton)
{
	resetvp ();
	statusBarMsg ("TIP : Right click draws filled rectangle.");
	setvp ();
	int b = 0, x, y;
	x = _x2 = _x1;
	y = _y2 = _y1;
	setwritemode (XOR_PUT);
	if (_bgColor)
		setcolor (_bgColor);
	else
		setcolor (YELLOW);
	setlinestyle (SOLID_LINE, 0, _thickness);
	do {
		getmousepos (&b, &x, &y);
		x -= _dl;
		y -= _dt;
		if (x != _x2 || y != _y2) {
			hidemouseptr ();
			rectangle (_x1, _y1, _x2, _y2);
			rectangle (_x1, _y1, x, y);
			showmouseptr ();
			_x2 = x;
			_y2 = y;
		}
	} while (b == 1 || b == 2);
	_x2 = x;
	_y2 = y;
	setcolor (_fgColor);
	setwritemode (COPY_PUT);
	hidemouseptr ();
	if (mouseButton == 2) {
		setfillstyle (_fillstyle, _fgColor);
		bar (_x1, _y1, _x2, _y2);
	}
	else {
		rectangle (_x1, _y1, _x2, _y2);
	}
	showmouseptr ();

}

void layout :: drawPolygon (int endflag, int xi, int yi)
{
	resetvp ();
	static int length = 0;
	setlinestyle (SOLID_LINE, 0, _thickness);
	if (endflag == -1) {
		if (length > 1) {
			setwritemode (COPY_PUT);
			resetvp();
			setcolor (_fgColor);
			setlinestyle (SOLID_LINE, 0, _thickness);
			line (_x2 + _dl, _y2 + _dt , _x1 + _dl, _y1 + _dt);
			resetCoordinates ();
			length = 0;
			clearStatusBar ();
		}
	}
	else if (length == 0) {
		statusBarMsg ("TIP : Turn off the button to complete the polygon.");
		setvp ();
		_x1 = xi;
		_y1 = yi;
		drawLine ();
		length ++;
	}
	else {
		statusBarMsg ("TIP : Turn off the button to complete the polygon.");
		setvp ();
		int b, x, y, oldx, oldy;
		oldx = x = _x2;
		oldy = y = _y2;
		if (_bgColor)
			setcolor (_bgColor);
		else
			setcolor (YELLOW);
		setwritemode (XOR_PUT);
		do {
			getmousepos (&b, &x, &y);
			x -= _dl;
			y -= _dt;
			if (x != _x2 || y != _y2) {
				hidemouseptr ();
				line (_x2, _y2, oldx, oldy);
				line (_x2, _y2, x, y);
				showmouseptr ();
				oldx = x;
				oldy = y;
			}
		}while (b == 1 || b == 2);
		setcolor (_fgColor);
		setwritemode (COPY_PUT);
		hidemouseptr ();
		line (_x2, _y2, x, y);
		length ++;
		showmouseptr ();
		_x2 = x;
		_y2 = y;
	}
	setlinestyle (SOLID_LINE, 0, 1);

}

void layout :: drawEllipse (int mouseButton)
{
	resetvp ();
	statusBarMsg ("TIP : Right click draws filled ellipse.");
	setvp ();

	int b = 0, x, y;
	x = _x2 = _x1;
	y = _y2 = _y1;
	int cx, cy, rx, ry;
	setwritemode (XOR_PUT);
	if (_bgColor)
		setcolor (_bgColor);
	else
		setcolor (YELLOW);
	setlinestyle (DOTTED_LINE, 0, 1);
	do {
		getmousepos (&b, &x, &y);
		x -= _dl, y -= _dt;
		if (x != _x2 || y != _y2) {
			hidemouseptr ();
			rectangle (_x1, _y1, _x2, _y2);
			rectangle (_x1, _y1, x, y);
			showmouseptr ();
			_x2 = x;
			_y2 = y;
		}
	} while (b == 1 || b == 2);
	cx = _x1 + (_x2 - _x1) / 2;
	cy = _y1 + (_y2 - _y1) / 2;
	rx = abs (_x1 - _x2) / 2;
	ry = abs (_y1 - _y2) / 2;
	hidemouseptr();
	rectangle (_x1, _y1, x, y);
	setcolor (_fgColor);
	setwritemode (COPY_PUT);

	setlinestyle (SOLID_LINE, 0, _thickness);
	if (mouseButton == 2) {
		setfillstyle (_fillstyle, _fgColor);
		fillellipse (cx, cy, rx, ry);
	}
	else {
		ellipse (cx, cy, 0, 360, rx, ry);
	}
	showmouseptr ();
}

void layout :: insertText ()
{
	resetvp ();
	statusBarMsg ("Press <ESC> to end.");
	setvp ();
	hidemouseptr ();
	char ch[2], buff[1024], c[2];
	ch[1] = NULL;
	c[1] = NULL;
	int x, y, i = 0;
	x = _x1, y = _y1;
	setcolor (_fgColor);
	setfillstyle (SOLID_FILL, _bgColor);
	settextstyle (_font, _fontDir, _fontSize);
	int y1, y2, x1, x2;
	while (int (ch[0] = getche ()) != 27) {
		if (int (ch[0]) == 13) {
			if (_fontDir == HORIZ_DIR) {
				y += textheight (ch);
				x = _x1;
			}
			else {
				x += textheight (ch);
				y = _y1;
			}
			buff[i++] = ch [0];
		}
		else if (int (ch[0]) == 8 && i > 0) {
		// backspace
			i --;
			c[0] = buff[i];
			if (_fontDir == HORIZ_DIR) {
				x -= textwidth (c);
				if (x < _x1) x = _x1;
				else {
					y1 = y;
					y2 = y + textheight (c);
					if (_font != 0) {
						y1 += textheight (c) / 4;
						y2 += textheight (c) / 4;
					}
					x1 = x;
					x2 = x + textwidth (c);
				}
			}
			else {
				y += textwidth (c);
				if (y > _y1) y = _y1;
				else {
					if (_font == 0) {
						y1 = y;
						y2 = y1 + textwidth (c);
						x2 = x;
						x1 = x - textheight (c);
					}
					else {
						x1 = x + textheight (c) / 4;
						x2 = x1 + textheight (c);
						y1 = y;
						y2 = y1 + textwidth (c);
					}
				}
			}
			bar (x1, y1, x2, y2);
			buff[i] = NULL;
		}  // end backspace
		else if (isprint (int (ch[0]))) {// || int (ch[0]) == 32){
			outtextxy (x, y, ch);
			if (_fontDir == HORIZ_DIR)
				x += textwidth (ch);
			else

				y -= textwidth (ch);
			buff[i++] = ch [0];
		}
		buff[i] = NULL;
	}
	showmouseptr ();
	settextstyle (0,0,1);
	resetvp ();
}

void layout :: saveFile (char * file)
{
	resetvp();
	statusBarMsg ("Please wait ...");
	hidemouseptr ();
	FILE *fp = fopen (file, "wb");

	for (int j = _dt + 1; j < _db; j++)
		for (int i = _dl + 1; i < _dr; i++)
			fputc (getpixel (i, j), fp);
	showmouseptr ();
	fclose (fp);
	statusBarMsg ("Ready.");
}
int layout :: openFile (const char *fileName)
{
	if (access (fileName, 04) != 0) {
		statusBarMsg ("Can't Read File.");
		return 0;
	}
	else {
		FILE *fp;
		fp = fopen (fileName, "rb");
		resetvp ();
		for (int j = _dt + 1; j < _db; j++)
			for (int i = _dl + 1; i < _dr; i++)
				putpixel (i, j, fgetc (fp));
		setvp ();
	}
	return 1;
}

void layout :: clearStatusBar ()
{
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	bar (_sl + 1, _st + 1, _sr - 20, _sb - 1);

}
void layout :: statusBarMsg (const char *message)
{
	clearStatusBar ();
	setcolor (BLACK);
	int y = _st + 5;
	int x = _sl + 5;
	outtextxy (x, y, message);
}
void layout :: getInput (const char* msg, char *input, int length)
{
	char buff[100];
	statusBarMsg (msg);
	hidemouseptr ();
	int i = 0, ch;
	while ((ch = getche ()) != 13 && i < length) {
		if (ch == 8) {
			if (i >= 1)
				input[--i] = '\0';
		}
		else {
			input[i++] = ch;
			input[i] = '\0';
		}
		sprintf (buff, "%s %s", msg, input);
		statusBarMsg (buff);
	}
	input[i] = '\0';
	showmouseptr ();
	clearStatusBar ();

}

void toolBarClick (layout *layout1, int mouseButton, int row, int col)
{
	int x, y;
	switch (col) {
		case 0:
			// New
			layout1->_fileName[0] = 0;
			setfillstyle (SOLID_FILL, WHITE);
			bar (layout1->_dl + 1, layout1->_dt + 1, layout1->_dr - 1, layout1->_db - 1);
			layout1->resetSelectionCoordinates ();
			break;
		case 1:
			// Open
			layout1->getInput ("Enter filename :", layout1->_fileName, 13);
			layout1->openFile (layout1->_fileName);
			layout1->resetvp ();
			break;
		case 2:
			// Save
			layout1->getInput ("Enter filename :", layout1->_fileName, 13);
			layout1->saveFile(layout1->_fileName);
			break;
		case 3:
			layout1->cut ();
			layout1->resetSelectionCoordinates ();
			break;
		case 4:
			layout1->copy ();
			layout1->resetSelectionCoordinates ();
			break;
		case 5:
			layout1->paste ();
			break;
		case 6:
			layout1->translate ();
			break;
		case 7:
			layout1->rotate ();
			break;
		case 8:
			layout1->scale ();
			break;
		case 9:
			layout1->clip ();
			break;
		case 10:
			//Help
			layout1->help ();
			break;

		case 11:
			//About
			layout1->about ();
			break;
	}
}

void editBoxClick (layout *layout1, int mouseButton, int row, int col)
{
/*	if (!row && !col && layout1->_editBox[0][0].state () == OFF) {
		layout1->setvp();
		layout1->deSelect ();
		layout1->resetSelectionCoordinates ();
		layout1->resetvp();
	}*/
	for (int i = 0; i < 7; i++)
		for (int j = 0; j < 2; j++) {
			if (layout1->_editBox[i][j].state() == ON && i != row || j != col) {
				layout1->_editBox[i][j].turnOff();
				layout1->_opr = NONE;
			}
		}
	if (layout1->_editBox[0][0].state () == OFF) {
		layout1->setvp ();
		layout1->deSelect ();
		layout1->resetSelectionCoordinates ();
		layout1->resetvp ();
	}
	if (layout1->_editBox[4][1].state() == OFF && layout1->_x1 != -1)
		layout1->drawPolygon (-1, -1, -1);
	if (layout1->_opr == NONE && layout1->_editBox[row][col].state () == ON) {

		layout1->_opr = 2 * row + col;

		switch (layout1->_opr) {
			default:
				break;
			case SPRAY :
				if (!layout1->_sprayBoxFlag)
					layout1->drawSprayBox ();
				break;
			case BRUSH:
				layout1->drawShapeBox (BLACK);
				break;
			case RUBBER:
				layout1->drawShapeBox (WHITE);
				break;
			case CURVE:
				layout1->drawThicknessBox ();
				layout1->saveFile ("temp.dpi");
				break;
			case LINE:
			case ART:
			case RECTANGLE:
			case ELLIPSE:
			case POLYGON:
			case PENCIL:
				layout1->drawThicknessBox();
				break;
			case INSERTTEXT:
				layout1->displayFontDialog ();
			case SPIRAL:
			case SELECT:
				break;
		}
	}
}
void layout :: deSelect ()
{
	_selected = FALSE;
	if (_sx1 != -1) {
		hidemouseptr ();
		setwritemode (XOR_PUT);
		setcolor (_selCol);

		setlinestyle (DOTTED_LINE, 0x1, 1);
		rectangle (_sx1, _sy1, _sx2, _sy2);
		setlinestyle (SOLID_LINE, 0, 1);
		setcolor (_fgColor);
		setwritemode (COPY_PUT);
		showmouseptr ();
	}
}
void layout :: operation (int x, int y, int mouseButton)
{
	setvp();
	if (_opr != SELECT && _selected == TRUE) {
		deSelect ();
		resetSelectionCoordinates ();
	}
	if (_opr != NONE) {
		if (_opr != POLYGON) {
			_x1 = x - _dl; _y1 = y - _dt;
		}
		switch (_opr) {
			case SELECT:
				select ();
				break;
			case RUBBER :
				rubber ();
				break;
			case FILL :
				fillColor ();
				break;
			case SPRAY :
				spray (_fgColor);
				break;
			case PENCIL :
				pencil ();
				break;
			case BRUSH :
				brush ();
				break;
			case LINE :
				drawLine ();
				break;
			case CURVE :
				drawCurve ();
				break;
			case RECTANGLE :
				drawRectangle (mouseButton);
				break;
			case POLYGON :
				drawPolygon (2, x - _dl, y - _dt);
				break;
			case ELLIPSE :
				drawEllipse (mouseButton);
				break;
			case INSERTTEXT :
				insertText ();
				break;
			case SPIRAL:
				drawSpiral ();
				break;
			case ART:
				drawLine (0);
				break;
			default :
				break;
		}
	}
	if (_opr != POLYGON)
		resetCoordinates ();
	resetvp();
}

void layout :: resetvp ()
{
	setviewport (0, 0, _MAXX, _MAXY, 1);
	restrictmouseptr (0, 0, _MAXX, _MAXY);
	setlinestyle (SOLID_LINE, 0, 1);
}
void layout :: setvp ()
{
	setviewport (_dl + 1, _dt + 1, _dr - 1, _db - 1, 1);
	restrictmouseptr (_dl, _dt, _dr - 2 , _db - 2);
}


void drawShadowBox (int x1, int y1, int x2, int y2, int flag)
{
	if (flag)
		setcolor (DARKGRAY);
	else
		setcolor (WHITE);
	line (x1, y1, x2, y1);
	line (x1, y1, x1, y2);
	if (flag)
		setcolor (WHITE);
	else
		setcolor (DARKGRAY);
	line (x1, y2, x2, y2);
	line (x2, y1, x2, y2);
}
void setSpray (layout *layout1, int button, int row, int col)
{
	for (int i = 0; i < 3; i++)
		if (i != row)
			layout1->_sprayBox[i].turnOff();
	layout1->_spraySize = row;
}
void setThickness (layout *layout1, int button, int row, int col)
{
	if (row == 0) {
		layout1->_thicknessBox[0].turnOn ();
		layout1->_thickness = 1;
		layout1->_thicknessBox[1].turnOff ();
	}
	else {
		layout1->_thicknessBox[1].turnOn ();
		layout1->_thickness = 3;
		layout1->_thicknessBox[0].turnOff ();
	}
}

void layout :: drawThicknessBox ()
{
	_thicknessBoxFlag = 1;
	_sprayBoxFlag = 0;
	_shapeBoxFlag = 0;
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	setcolor (LIGHTGRAY);
	bar (5, _eb + 5, 57, _eb + 100);

	drawShadowBox (12, _eb + 10, 51, _eb + 43, 1);
	_thicknessBox[0].setProperties (13, _eb + 11, 50, _eb + 26, TOGGLE, OFF, setThickness);
	_thicknessBox[1].setProperties (13, _eb + 27, 50, _eb + 42, TOGGLE, OFF, setThickness);

	if (_thickness == 1)
		_thicknessBox[0].turnOn();
	else
		_thicknessBox[1].turnOn();
	setcolor (BLACK);
	setlinestyle (SOLID_LINE, 0x1, 1);
	line (18, _eb + 19, 45, _eb + 19);
	setlinestyle (SOLID_LINE, 0x1, 3);
	line (18, _eb + 35, 45, _eb + 35);

	setlinestyle (SOLID_LINE, 0x1, 1);
}

void layout :: drawSprayBox ()
{
	_thicknessBoxFlag = 0;
	_sprayBoxFlag = 1;
	_shapeBoxFlag = 0;
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	setcolor (LIGHTGRAY);
	bar (5, _eb + 5, 57, _eb + 100);

	drawShadowBox (21, _eb + 10, 43, _eb + 74, 1);
	_sprayBox[0].setProperties (22, _eb + 11, 42, _eb + 31, TOGGLE, OFF, setSpray);
	_sprayBox[1].setProperties (22, _eb + 32, 42, _eb + 52, TOGGLE, OFF, setSpray);
	_sprayBox[2].setProperties (22, _eb + 53, 42, _eb + 73, TOGGLE, OFF, setSpray);
	_x1 = 32, _y1 = _eb + 21;
	int temp = _spraySize;
	_spraySize = 0;
	while (_spraySize < 3) {
		for (int i = 0; i < 30 * (_spraySize + 1); i++)
			spray (BLACK);
		_y1 += 21;
		_spraySize ++;
	}
	_spraySize = temp;
	_sprayBox[_spraySize].turnOn();
}

void layout :: drawShapeBox (int color)
{
	_thicknessBoxFlag = 0;
	_sprayBoxFlag = 0;
	_shapeBoxFlag = 1;
	setfillstyle (SOLID_FILL, LIGHTGRAY);
	setcolor (LIGHTGRAY);
	bar (5, _eb + 5, 57, _eb + 100);
	_shapeBoxFlag = 1;
	drawShadowBox (12, _eb + 6, 51, _eb + 49, 1);
	_shapeBox[0][0].setProperties (13, _eb + 7, 31, _eb + 27, TOGGLE, OFF, setShape);
	_shapeBox[0][1].setProperties (32, _eb + 7, 50, _eb + 27, TOGGLE, OFF, setShape);
	_shapeBox[1][0].setProperties (13, _eb + 28, 31, _eb + 48, TOGGLE, OFF, setShape);
	_shapeBox[1][1].setProperties (32, _eb + 28, 50, _eb + 48, TOGGLE, OFF, setShape);


	setcolor (color);
	setfillstyle (SOLID_FILL, color);
	fillellipse (22, _eb + 17, 2, 2);
	fillellipse (41, _eb + 17, 4, 4);
	bar (21, _eb + 37, 23, _eb + 39);
	bar (39, _eb + 36, 43, _eb + 40);
	if (_shape == SMALLCIRCLE)
		_shapeBox[0][0].turnOn();
	else if (_shape == BIGCIRCLE)
		_shapeBox[0][1].turnOn();
	else if (_shape == SMALLSQUARE)
		_shapeBox[1][0].turnOn();
	else if (_shape == BIGSQUARE)
		_shapeBox[1][1].turnOn();


}

void changeColor (layout *layout1, int mouseButton, int row, int col)
{

	if (mouseButton == 1) {
		layout1->statusBarMsg ("TIP : Right click selects background color.");
		layout1->fgColor() = color [col * 2 + row];
	}
	else
		layout1->bgColor() = color [col * 2 + row];
	layout1->setColors ();
}

void layout :: setColors ()
{
	setcolor (WHITE);
	line (_cl + 15, _ct + 15, _cl + 27, _ct + 15);
	line (_cl + 15, _ct + 15, _cl + 15, _ct + 27);
	setcolor (DARKGRAY);
	line (_cl + 15, _ct + 27, _cl + 27, _ct + 27);
	line (_cl + 27, _ct + 15, _cl + 27, _ct + 27);
	setcolor (LIGHTGRAY);
	rectangle (_cl + 16, _ct + 16, _cl + 26, _ct + 26);
	setfillstyle (SOLID_FILL, _bgColor);
	bar (_cl + 17, _ct + 17, + _cl + 25, _ct + 25);
	setcolor (WHITE);
	line (_cl + 8, _ct + 20, _cl + 8, _ct + 8);
	line (_cl + 8, _ct + 8, _cl + 20, _ct + 8);
	setcolor (DARKGRAY);
	line (_cl + 8, _ct + 20, _cl + 20, _ct + 20);
	line (_cl + 20, _ct + 8, _cl + 20, _ct + 20);
	setfillstyle (SOLID_FILL, _fgColor);
	bar (_cl + 10, _ct + 10, _cl + 18, _ct + 18);
	setcolor (LIGHTGRAY);
	rectangle (_cl + 9, _ct + 9, _cl + 19, _ct + 19);
}

void layout :: drawIcons ()
{
	int x1, y1, x2, y2, i = 0, j = 0, a, b, c, d, flag, k, l;
	for (i = 0; i < TOOLBARSIZE; i++) {
		x1 = _toolBar[i].xLeft ();
		x2 = _toolBar[i].xRight ();
		y1 = _toolBar[i].yTop ();
		y2 = _toolBar[i].yBot ();
		switch (i) {
			case 0:
				setcolor (BLACK);
				moveto (x1 + 5, y1 + 3);
				lineto (x1 + 5, y1 + 17);
				lineto (x1 + 15, y1 + 17);
				lineto (x1 + 15, y1 + 8);
				lineto (x1 + 12, y1 + 3);
				lineto (x1 + 5, y1 + 3);
				setfillstyle (SOLID_FILL, WHITE);
				floodfill ( x1 + 6, y1 + 6, BLACK);
				moveto (x1 + 12, y1 + 3);
				lineto (x1 + 12, y1 + 7);
				lineto (x1 + 15, y1 + 7);
				break;
			case 1 :
				moveto (x1 + 3, y1 + 3);
				lineto (x1 + 3, y1 + 17);
				lineto (x1 + 14, y1 + 17);
				lineto (x1 + 17, y1 + 10);
				lineto (x1 + 7, y1 + 10);
				lineto (x1 + 3, y1 + 17);
				moveto (x1 + 14, y1 + 10);
				lineto (x1 + 14, y1 + 6);
				lineto (x1 + 7, y1 + 6);
				lineto (x1 + 7, y1 + 3);
				lineto (x1 + 3, y1 + 3);
				setfillstyle (SOLID_FILL, YELLOW);
				floodfill (x1 + 5, y1 + 6, BLACK);
				floodfill (x1 + 14, y1 + 11, BLACK);
				arc (x1 + 13, y1 + 8, 30, 90, 5);
				moveto (x1 + 16, y1 + 6);
				lineto (x1 + 18, y1 + 6);
				lineto (x1 + 18, y1 + 4);
				break;
			case 2:
				moveto (x1 + 3, y1 + 3);
				lineto (x1 + 17, y1 + 3);
				lineto (x1 + 17, y1 + 17);
				lineto (x1 + 5, y1 + 17);
				lineto (x1 + 3, y1 + 15);
				lineto (x1 + 3, y1 + 3);
				rectangle (x1 + 6, y1 + 3, x1 + 14, y1 + 10);
				rectangle (x1 + 6, y1 + 12, x1 + 14, y1 + 17);
				rectangle (x1 + 11, y1 + 13, x1 + 13, y1 + 17);
				setfillstyle (SOLID_FILL, BLACK);
				floodfill (x1 + 10, y1 + 15, BLACK);
				setfillstyle (SOLID_FILL, BROWN);
				floodfill (x1 + 5, y1 + 5, BLACK);
				break;
			case 3 :
				moveto (x1 + 7, y1 + 3);
				lineto (x1 + 10, y1 + 12);
				lineto (x1 + 13, y1 + 3);
				moveto (x1 + 10, y1 + 12);
				lineto (x1 + 7, y1 + 17);
				moveto (x1 + 10, y1 + 12);
				lineto (x1 + 13, y1 + 17);
				arc (x1 + 8, y1 + 14, 45, 260, 2);
				arc (x1 + 12, y1 + 14, 300, 135, 2);
				break;
			case 4:
				moveto (x1 + 3, y1 + 2);
				lineto (x1 + 3, y1 + 12);
				lineto (x1 + 8 ,y1 + 12);
				lineto (x1 + 8, y1 + 18);
				lineto (x1 + 17, y1 + 18);
				lineto (x1 + 17, y1 + 11);
				lineto (x1 + 14, y1 + 8);
				lineto (x1 + 11, y1 + 8);
				lineto (x1 + 11, y1 + 5);
				lineto (x1 + 8, y1 + 2);
				lineto (x1 + 3, y1 + 2);
				setfillstyle (SOLID_FILL, WHITE);
				floodfill (x1 + 4, y1 + 4, BLACK);
				moveto (x1 + 8, y1 + 2);
				lineto (x1 + 8, y1 + 6);
				lineto (x1 + 11, y1 + 6);
				moveto (x1 + 8, y1 + 13);
				lineto (x1 + 8, y1 + 8);
				lineto (x1 + 14, y1 + 8);
				lineto (x1 + 14, y1 + 11);
				lineto (x1 + 17, y1 + 11);
				break;
			case 5:
				setfillstyle (SOLID_FILL, BROWN);
				bar3d ( x1 + 3, y1 + 5, x1 + 13, y1 + 17, 1, 0);
				setcolor (YELLOW);
				moveto (x1 + 5, y1 + 6);
				lineto (x1 + 11, y1 + 6);
				lineto (x1 + 9, y1 + 4);
				lineto (x1 + 7, y1 + 4);
				lineto (x1 + 5, y1 + 6);
				setfillstyle (SOLID_FILL, YELLOW);
				floodfill (x1 + 9, y1 + 5, YELLOW);
				setcolor (BLACK);
				moveto (x1 + 5, y1 + 6);
				lineto (x1 + 11, y1 + 6);
				lineto (x1 + 9, y1 + 2);
				lineto (x1 + 7, y1 + 2);
				lineto (x1 + 5, y1 + 6);

				moveto (x1 + 8, y1 + 10);
				lineto (x1 + 8, y1 + 18);
				lineto (x1 + 16, y1 + 18);
				lineto (x1 + 16, y1 + 13);
				lineto (x1 + 13, y1 + 10);
				lineto (x1 + 8, y1 + 10);
				setfillstyle (SOLID_FILL, WHITE);
				floodfill (x1 + 9, y1 + 11, BLACK);
				floodfill (x1 + 15, y1 + 14, BLACK);
				setcolor (WHITE);
				line (x1 + 13, y1 + 17, x1 + 13, y1 + 11);
				line (x1 + 14, y1 + 17, x1 + 14, y1 + 12);
				line (x1 + 9, y1 + 17, x1 + 13, y1 + 17);
				setcolor (BLACK);
				break;
/*			case 6 :
				setfillstyle (SOLID_FILL, BLACK);
				bar (x1 + 5, y1 + 9, x1 + 13, y1 + 11);
				moveto (x1 + 12, y1 + 7);
				lineto (x1 + 12, y1 + 13);
				lineto (x1 + 15, y1 + 10);
				lineto (x1 + 12, y1 + 7);
				floodfill (x1 + 14, y1 + 10, BLACK);

				break;
			case 7 :
				setfillstyle (SOLID_FILL, BLACK);
				bar (x1 + 9, y1 + 8, x1 + 11, y1 + 15);
				moveto (x1 + 7, y1 + 8);
				lineto (x1 + 13, y1 + 8);
				lineto (x1 + 10, y1 + 5);
				lineto (x1 + 7, y1 + 8);
				floodfill (x1 + 10, y1 + 6, BLACK);
				break;
*/
			case 6:
				setcolor (BLACK);
				setlinestyle (USERBIT_LINE, 0xaaaa, 1);
				rectangle (x1 + 2, y1 + 2, x1 + 12, y1 + 12);
				rectangle (x1 + 7, y1 + 7, x1 + 17, y1 + 17);
				setlinestyle (SOLID_LINE, 0, 1);
				break;
			case 7:
				arc (x1 + 10, y1 + 10, 300, 150, 7);
				moveto (x1 + 4, y1 + 3);
				lineto (x1 + 4, y1 + 5);
				lineto (x1 + 7, y1 + 6);
				break;
			case 8:
				rectangle (x1 + 3, y1 + 3, x1 + 17, y1 + 17);
				setfillstyle (SOLID_FILL, BLACK);
				bar (x1 + 7, y1 + 9, x1 + 13, y1 + 11);
				moveto (x1 + 13, y1 + 7);
				lineto (x1 + 13, y1 + 13);
				lineto (x1 + 16, y1 + 10);
				lineto (x1 + 13, y1 + 7);
				moveto (x1 + 7, y1 + 7);
				lineto (x1 + 7, y1 + 13);
				lineto (x1 + 4, y1 + 10);
				lineto (x1 + 7, y1 + 7);
				floodfill (x1 + 5, y1 + 10, BLACK);
				floodfill (x1 + 14, y1 + 10, BLACK);
				break;
			case 9:
				setlinestyle (USERBIT_LINE, 0xaaaa, 1);
				rectangle (x1 + 5, y1 + 5, x1 + 15, y1 + 15);
				setcolor (RED);
				setlinestyle (SOLID_LINE, 0, 1);
				moveto (x1 + 8, y1 + 2);
				lineto (x1 + 11, y1 + 5);
				lineto (x1 + 8, y1 + 8);
				moveto (x1 + 17, y1  + 2);
				lineto (x1 + 11, y1 + 5);
				lineto (x1 + 17, y1 + 8);
				moveto (x1 + 17, y1 + 2);
				lineto (x1 + 14, y1 + 2);
				lineto (x1 + 14, y1 + 4);
				moveto (x1 + 17, y1 + 8);
				lineto (x1 + 14, y1 + 8);
				moveto (x1 + 14, y1 + 6);
				break;

			case 10:
				setcolor (BLACK);
				arc (x1 + 10, y1 + 8, 270, 180, 5);
				arc (x1 + 10, y1 + 8, 270, 180, 3);
				line (x1 + 5, y1 + 8, x1 + 7, y1 + 8);
				line (x1 + 10, y1 + 11, x1 + 10, y1 + 13);
				setfillstyle (SOLID_FILL, BLACK);
				floodfill (x1 + 8, y1 + 4, BLACK);
				bar (x1 + 9, y1 + 12, x1 + 11, y1 + 14);
				bar (x1 + 9, y1 + 16, x1 + 11, y1 + 18);
				break;
			case 11:
				setcolor (RED);
				settextstyle (0, 0, 1);
				outtextxy (x1 + 2, y1 + 7, "d");
				setcolor (YELLOW);
				outtextxy (x1 + 10, y1 + 7, "P");
				settextstyle (0, 0, 1);
				break;
		}
	}

	for (i = 0; i < 7; i ++)
		for (j = 0; j < 2; j++) {
			x1 = _editBox[i][j].xLeft ();
			x2 = _editBox[i][j].xRight ();
			y1 = _editBox[i][j].yTop ();
			y2 = _editBox[i][j].yBot ();
			switch (2 * i + j) {
				case 0 : // select region
					setcolor (BLACK);
					setlinestyle (USERBIT_LINE, 0xaaaa, 1);
					rectangle (x1 + 3, y1 + 5, x2 - 3, y2 - 5);
					setlinestyle (SOLID_LINE, 0x1, 1);
					break;
				case 1 :
					setcolor (DARKGRAY);
					rectangle (x1 + 3, y1 + 15, x1 + 13, y1 + 20);
					setfillstyle (SOLID_FILL, WHITE);
					floodfill (x1 + 6, y1 + 16, DARKGRAY);
					line (x1 + 3, y1 + 15, x1 + 13, y1 + 5);
					line (x1 + 13, y1 + 15, x1 + 23, y1 + 5);
					line (x1 + 13, y1 + 5, x1 + 23, y1 + 5);
					line (x1 + 23, y1 + 5, x1 + 23, y1 + 10);
					line (x1 + 23, y1 + 10, x1 + 13, y1 + 20);
					setfillstyle (SOLID_FILL, YELLOW);
					floodfill (x1 + 12, y1 + 14, DARKGRAY);
					floodfill (x1 + 14, y1 + 18, DARKGRAY);
					break;
				case 2:
					setcolor (LIGHTBLUE);
					moveto (x1 + 23, y1 + 15);
					lineto (x1 + 17, y1 + 21);
					lineto (x1 + 10, y1 + 14);
					lineto (x1 + 16, y1 + 8);
					lineto (x1 + 23, y1 + 15);

					moveto (x1 + 20, y1 + 12);
					lineto (x1 + 8, y1 + 12);
					lineto (x1 + 6, y1 + 14);
					lineto (x1 + 6, y1 + 20);
					lineto (x1 + 8, y1 + 18);
					lineto (x1 + 10, y1 + 14);
					setfillstyle (SOLID_FILL, LIGHTBLUE);
					floodfill (x1 + 7, y1 + 14, LIGHTBLUE);
					floodfill (x1 + 20, y1 + 15, LIGHTBLUE);

					setcolor (BLACK);
					moveto (x1 + 23, y1 + 15);
					lineto (x1 + 17, y1 + 21);
					lineto (x1 + 10, y1 + 14);
					lineto (x1 + 16, y1 + 8);
					lineto (x1 + 23, y1 + 15);

					moveto (x1 + 12, y1 + 17);
					lineto (x1 + 19, y1 + 10);
					moveto (x1 + 13, y1 + 18);
					lineto (x1 + 20, y1 + 11);

					break;
				case 3 :
					setcolor (BLACK);
					rectangle (x1 + 14, y1 + 12, x1 + 20, y1 + 21);
					setfillstyle (SOLID_FILL, RED);
					floodfill (x1 + 15, y1 + 13, BLACK);
					arc ( x1 + 17, y1 + 12, 0, 180, 3);
					bar (x1 + 16, y1 + 7, x1 + 18, y1 + 9);
					for (a = x1 + 9, c = 0; a < x1 + 15; a ++, c ++) {
						flag = 0;
						for (b = y1 + 2; b < y1 + 14; b ++) {
							d = b + c;
							if (flag && d < y1 + 14 - c) {
								putpixel (a, d, RED);
								flag = 0;
							}
							else
								flag = 1;
							}
					}
					break;
				case 4 :
					moveto (x1 + 6, y2 - 8);
					lineto (x1 + 3, y2 - 3);
					lineto (x1 + 8, y2 - 6);
					lineto (x1 + 6, y2 - 8);
					lineto (x1 + 20, y2 - 22);
					lineto (x1 + 22, y2 - 20);
					lineto (x1 + 8, y2 - 6);
					moveto (x1 + 17, y2 - 19);
					lineto (x1 + 19, y2 - 17);
					setfillstyle (SOLID_FILL, BLACK);
					floodfill (x1 + 5, y2 - 5, BLACK);
					floodfill (x1 + 6, y2 - 6, BLACK);
					setfillstyle (INTERLEAVE_FILL, YELLOW);
					floodfill (x1 + 10, y2 - 10, BLACK);
					setfillstyle (SOLID_FILL, RED);
					floodfill (x1 + 21, y2 - 20, BLACK);
					break;
				case 5 :
					setfillstyle (SOLID_FILL, YELLOW);
					bar (x1 + 11, y1 + 5, x1 + 13, y1 + 15);
					setcolor (YELLOW);
					line (x1 + 11, y1 + 15, x1 + 8, y1 + 17);
					line (x1 + 13, y1 + 15, x1 + 16, y1 + 17);
					line (x1 + 8, y1 + 17, x1 + 16, y1 + 17);
					floodfill (x1 + 12, y1 + 16, YELLOW);
					pieslice (x1 + 12, y1 + 5, 0, 180, 1);
					setcolor (WHITE);
					rectangle (x1 + 7, y1 + 18, x1 + 17, y1 + 23);
					setfillstyle (SOLID_FILL, WHITE);
					floodfill (x1 + 8, y1 + 19, WHITE);
					setcolor (BLACK);
					line (x1 + 7, y1 + 18, x1 + 17, y1 + 18);
					line (x1 + 9, y1 + 23, x1 + 9, y1 + 21);
					line (x1 + 12, y1 + 23, x1 + 12, y1 + 21);
					line (x1 + 15, y1 + 23, x1 + 15, y1 + 21);
					break;
				case 6 :
					line (x1 + 4, y1 + 4, x2 - 4, y2 - 4);
					break;
				case 7 :
					arc (x1 + 9, y1 + 9, 315, 135, 5);
					arc (x1 + 16, y1 + 16, 135, 315, 5);
					break;
				case 8 :
					rectangle (x1 + 5, y1 + 7, x2 - 5, y2 - 7);
					break;
				case 9 :
					moveto (x1 + 20, y1 + 20);
					lineto (x1 + 5, y1 + 20);
					lineto (x1 + 12, y1 + 7);
					lineto (x1 + 18, y1 + 7);
					lineto (x1 + 13, y1 + 15);
					lineto (x1 + 20, y1 + 15);
					lineto (x1 + 20, y1 + 20);
					break;
				case 10 :
					ellipse (x1 + 13, y1 + 12, 0, 360, 10, 5);
					break;
				case 11 :
					settextstyle (4, 0, 2);
					outtextxy (x1 + 5, y1, "A");
					settextstyle (0,0,1);
					break;
				case 12: // ART
					for (k = 5; k <= 17; k += 4) {
						moveto (x1 + 12, y1 + 5);
						lineto (x1 + k , y1 + 17);
						moveto (x1 + 12, y1 + 5);
						lineto (x1 + k + 2, y1 + 12);
					}
					break;
				case 13:
					setcolor (BLACK);
					for (k = 0; k < 12; k += 4) {
						arc (x1 + 11, y1 + 12, 0, 180, k);
						arc (x1 + 13, y1 + 12, 180, 360, k + 2);
					}

					break;

			}
		}

}

layout :: layout ()
{
	_font = 0;
	_fontSize = 1;
	_fontDir = HORIZ_DIR;
	_selected = FALSE;
	_fileName[0] = NULL;
	_sprayBoxFlag = _shapeBoxFlag = _thicknessBoxFlag = 0;
	_MAXX = getmaxx ();
	_MAXY = getmaxy ();
	_layoutColor = LIGHTGRAY;
	_titleBarColor = LIGHTBLUE;
	_bgColor = WHITE;
	_fgColor = BLACK;
	_thickness = 1;
	_fillstyle = SOLID_FILL;
	_opr = NONE;
	resetCoordinates ();
	_shape = BIGSQUARE;
	_spraySize = 0;
	_sx1 = _sy1 = _sx2 = _sy2 = -1;
	// title bar position
	_Tl = 0, _Tt = 0, _Tr = _MAXX, _Tb = 15;
	//quit button position
	_ql = _Tr - 12, _qt = _Tt + 2, _qr = _Tr - 2, _qb = _Tb - 2;

	_tl = 1, _tt = _Tb + 2, _tb = _tt + 30;
	_el = 5, _et = _tb + 7, _er = _el + 53, _eb = _et + 183;
	_sl = 1, _st = _MAXY - 20, _sr = _MAXX - 1, _sb = _MAXY - 1; // status
	_cl = 5, _cr = _cl + 165, _cb = _st - 5, _ct = _cb - 35;
	_dl = _er + 6, _dt = _tb + 1 , _dr = _MAXX - 3, _db = _ct - 6;

//	_pl, _pt, _pr, _pb; // pattern

	 drawLayout ();
}

void layout :: drawLayout ()
{
	setcolor (_layoutColor);
	rectangle (0, 0, _MAXX, _MAXY);
	setfillstyle (SOLID_FILL, _layoutColor);
	floodfill (1, 1, _bgColor);

	//Draw title bar;
	setcolor (_titleBarColor);
	rectangle (_Tl, _Tt, _Tr, _Tb);
	setfillstyle (SOLID_FILL, _titleBarColor);
	floodfill (1, 1, _titleBarColor);
	_quitButton.setProperties ( _ql, _qt, _qr, _qb, NORMAL, OFF, quit);
	outtextxy (_ql + 2, _qt + 2, "X");
	outtextxy (_Tl + 5, _Tt + 5, "dPaint");


	int i = 0, x, y, width, height, x1, x2, x3, y1, y2, y3;
	width = height = 20;
	x = _tl + 5; y = _tt + 5;
	for (i = 0; i < TOOLBARSIZE; i ++) {
		_toolBar[i].setProperties (x, y, x + width, y + height, NORMAL, OFF, toolBarClick);
		x += width + 2;
		if (i == 2 || i == 5 || i == 9) {
			x += 5;
			setcolor (DARKGRAY);
			line (x, _tt + 2, x, _tb - 2);
			setcolor (WHITE);
			x++;
			line (x, _tt + 2, x, _tb - 2);
			x += 5;
		}
	}
	x += 5;
	setcolor (DARKGRAY);
	line (x, _tt + 2, x, _tb - 2);
	setcolor (WHITE);
	x++;
	line (x, _tt + 2, x, _tb - 2);
	_tr = x + 5;


	setcolor (DARKGRAY);
	line (0, _tt - 2, _MAXX, _tt - 2);
	line (0, _tb + 1, _dl, _tb + 1);
	setcolor (WHITE);
	line (0, _tt - 1, _MAXX, _tt - 1);
	line (0, _tb + 2, _dl, _tb + 2);

	setcolor (WHITE);
	rectangle (_dl, _dt, _dr + 1, _db + 1);
	setfillstyle (SOLID_FILL, WHITE);
	floodfill (_dl + 1, _dt + 1, WHITE);
	setcolor (DARKGRAY);
	rectangle (_dl, _dt, _dr, _db);


//      edit bar
	drawShadowBox (_el, _et, _er, _eb, 1);

	x = _el + 1; y = _et + 1;
	height = width = 25;
	x1 = _el + 1 + width;
	x2 = x1 + 1;
	x3 = x2 + width;
	for (i = 0; i < 7; i ++) {
		y1 = y + width;
		_editBox[i][0].setProperties (x, y, x1, y1, TOGGLE, OFF, editBoxClick);
		_editBox[i][1].setProperties (x2, y, x3, y1, TOGGLE, OFF, editBoxClick);
		y = y1 + 1;
	}
	drawIcons ();




//      draw color bar
	setcolor (DARKGRAY);
	line (0, _ct - 6, _dl, _ct - 6); // Separator
	setcolor (WHITE);
	line (1, _ct - 5, _dl, _ct - 5); // Separator
	drawShadowBox (_cl, _ct, _cr, _cb, 1);

	x = _cl, y = _ct;

	width = 15, height = 15;
	x += 2;
	y += 2;

	x1 = x + 2 * width + 2;
	y1 = y + 2 * height + 1;

	setColors ();

	drawShadowBox (x, y, x1, y1, 1);

	x = x1 + 2;
	y1 = y + height;
	int cc;
	extern int color[16];

	for (i = 0; i < 8; i ++) {
		x1 = x + width;
		cc = color [2 * i];
		_colorBox[0][i].setProperties (x, y, x1, y1, NORMAL, OFF, changeColor);
		setcolor (cc);
		rectangle (x+2, y+2, x1-2, y1-2);
		setfillstyle (SOLID_FILL, cc);
		floodfill (x+3, y+3, cc);
		y2 = y1 + 1;
		y3 = y2 + height;
		cc = color [2 * i + 1];
		_colorBox[1][i].setProperties (x, y2, x1, y3, NORMAL, OFF, changeColor);
		setcolor (cc);
		rectangle (x + 2, y2 + 2, x1 - 2, y3 - 2);
		setfillstyle (SOLID_FILL, cc);
		floodfill (x + 3, y2 + 3, cc);
		x = x1 + 1;

	}
 /*
 black darkgray  blue 	  cyan      red      lightmagenta brown  green
 white lightgray lightblue lightcyan lightred magenta	  yellow ligthgreen*/
	//draw statusbar
	drawShadowBox (_sl, _st, _sr, _sb, 1);
	showmouseptr ();
}

void layout :: checkRegions (int x, int y, int button)
{
	// check if quitutton
	if (button == 1)
		_quitButton.checkAndAct (this, x, y, button, -1, -1);
	int i, j;
	for (j = 0; j < TOOLBARSIZE; j++)
		_toolBar[j].checkAndAct (this, x, y, button, -1, j);
	for (i = 0; i < 7; i++)
		for (j = 0; j < 2; j++)
			_editBox[i][j].checkAndAct (this, x, y, button, i, j);

	for (i = 0; i < 2; i++)
		for (j = 0; j < 8; j++)
			_colorBox [i][j].checkAndAct (this, x, y, button, i, j);
/*	for (i = 0; i < 2; i++)
		for (j = 0; j < 5; j++)
			patternBox [i][j].checkAndAct (x, y);
*/

	if (_shapeBoxFlag)
		for (i = 0; i < 2; i++)
			for (j = 0; j < 2; j++)
				_shapeBox [i][j].checkAndAct (this, x, y, button, i, j);
	if (_thicknessBoxFlag)
		for (i = 0; i < 2; i++)
			_thicknessBox [i].checkAndAct (this, x, y, button, i, -1);
	if (_sprayBoxFlag)
		for (i = 0; i < 3; i ++)
			_sprayBox [i].checkAndAct (this, x, y, button, i, -1);

	if (x > _dl && x < _dr && y > _dt && y < _db) {
		clearStatusBar ();
		operation (x, y, button);
	}
}

void button :: checkAndAct (layout *layout1, int x, int y, int mouseButton, int row, int col)
{
	if (checkRegion (x, y)) {
		layout1->clearStatusBar ();
		action (layout1, mouseButton, row, col);
	}
}
int button :: state ()
{
	if (_state | OFF) return ON;
	else return OFF;
}
int button :: type ()
{
	if (_type | NORMAL) return TOGGLE;
	else return NORMAL;
}
void button :: action (layout *layout1, int mouseButton, int row, int col)
{
	if (type () == NORMAL)
		turnOn();
	else
		toggle ();
	delay (250);
	_action (layout1, mouseButton, row, col);
	if (type () == NORMAL)
		turnOff();
}

int button :: checkRegion (int x, int y)
{
	return (x >= _xLeft && x <= _xRight && y >= _yTop && y <= _yBot);
}

void button :: setProperties (int xl, int yt, int xr, int yb, int type, int stat, void (*act) (layout *, int, int, int))
{
	_xLeft = xl;
	_xRight = xr;
	_yTop = yt;
	_yBot = yb;
	_state = stat;
	_type = type;
	if (act == 0)
		_action = defaultButtonAction;
	else
		_action = act;
	if (state () == OFF)
		turnOff ();
	else
		turnOn ();
}


void button :: turnOff ()
{
	hidemouseptr ();
	setcolor (WHITE);
	line (_xLeft, _yTop, _xRight, _yTop);
	line (_xLeft, _yTop, _xLeft, _yBot);
	setcolor (BLACK);
	line (_xRight, _yTop, _xRight, _yBot);
	line (_xRight, _yBot, _xLeft, _yBot);
	_state = OFF;
	showmouseptr ();
}

void button :: turnOn ()
{
	hidemouseptr ();
	setcolor (BLACK);
	line (_xLeft, _yTop, _xRight, _yTop);
	line (_xLeft, _yTop, _xLeft, _yBot);
	setcolor (WHITE);
	line (_xRight, _yTop, _xRight, _yBot);
	line (_xRight, _yBot, _xLeft, _yBot);

	_state = ON;
	showmouseptr ();
}

void button :: toggle ()
{
	if (state () == ON) {
		turnOff ();
	}
	else
		turnOn ();
}



initmouse()
{
	i.x.ax=0;
	int86(0x33,&i,&o);
	return(o.x.ax);
}

void showmouseptr()
{
	i.x.ax=1;
	int86(0x33,&i,&o);
}

void restrictmouseptr(int x1,int y1,int x2,int y2)
{
	i.x.ax=7;
	i.x.cx=x1;
	i.x.dx=x2;
	int86(0X33,&i,&o);
	i.x.ax=8;
	i.x.cx=y1;
	i.x.dx=y2;
	int86(0x33,&i,&o);
}

void hidemouseptr()
{
	i.x.ax=2;
	int86(0x33,&i,&o);
}

void getmousepos(int *butt,int *x,int *y)
{
	i.x.ax=3;
	int86(0x33,&i,&o);
	*butt=o.x.bx;
	*x=o.x.cx;
	*y=o.x.dx;
}
void defaultButtonAction (layout *layout1, int mouseButton, int row, int col)
{
}

void quit (layout *layout1, int mouseButton, int row, int col)
{
	closegraph ();
	if (access ("copybuf.dpi", 00) == 0)
		unlink ("copybuf.dpi");
	if (access ("transbuf.dpi", 00) == 0)
		unlink ("transbuf.dpi");
	if (access ("temp.dpi", 00) == 0)
		unlink ("temp.dpi");
	if (access ("tempbuf.dpi", 00) == 0)
		unlink ("tempbuf.dpi");


	exit (0);
}


int main ()
{
	int gd=DETECT, gm;
	initgraph (&gd, &gm, "");
	initmouse ();
	layout layout1;
	int mousebut = 0, x, y;
	while (1) {
		getmousepos (&mousebut, &x, &y);
		if (mousebut != 0)
			layout1.checkRegions (x, y, mousebut);
	}
}

